%global enable_tests 1

Name:           nodejs-sqlite3
Version:        2.1.7
Release:        1%{?dist}
Summary:        Asynchronous, non-blocking SQLite3 bindings for Node.js

License:        BSD
URL:            https://github.com/developmentseed/node-sqlite3
Source0:        http://registry.npmjs.org/sqlite3/-/sqlite3-%{version}.tgz
# Link against system libraries
Patch0:         nodejs-sqlite3-libraries.patch
# Fix path for binary object to match packaging guidelines
Patch1:         nodejs-sqlite3-paths.patch
# Offered upstream - https://github.com/developmentseed/node-sqlite3/pull/117
Patch2:         nodejs-sqlite3-async.patch
# Offered upstream - https://github.com/developmentseed/node-sqlite3/pull/121
Patch3:         nodejs-sqlite3-callbacks.patch
# Offered upstream - https://github.com/developmentseed/node-sqlite3/pull/132
Patch4:         nodejs-sqlite3-tests.patch

ExclusiveArch:  %{ix86} x86_64 %{arm}

BuildRequires:  nodejs-devel
BuildRequires:  node-gyp
BuildRequires:  sqlite-devel

%if 0%{?enable_tests}
BuildRequires:  npm(mocha)
BuildRequires:  npm(step)
%endif

%{?nodejs_default_filter}

%description
%summary


%prep
%setup -q -n package
%patch0 -p0 -b .libraries
%patch1 -p0
%patch2 -p1 -b .async
%patch3 -p1 -b .callbacks
%patch4 -p1 -b .tests
rm -rf deps node_modules


%build
export CXXFLAGS="%{optflags}"
node-gyp rebuild


%install
mkdir -p %{buildroot}/%{nodejs_sitearch}/sqlite3
cp -pr package.json lib %{buildroot}/%{nodejs_sitearch}/sqlite3
mkdir -p %{buildroot}/%{nodejs_sitearch}/sqlite3/build
install -p -D -m0755 build/Release/node_sqlite3.node %{buildroot}%{nodejs_sitearch}/sqlite3/build
%nodejs_symlink_deps


%if 0%{?enable_tests}
%check
%nodejs_symlink_deps --check
ln -s Release/node_sqlite3.node build/node_sqlite3.node
%{__nodejs} test/support/createdb.js
mkdir test/tmp
NODE_PATH=lib %{nodejs_sitelib}/mocha/bin/mocha -R spec -t 120000
%endif


%files
%doc LICENSE README.md examples
%{nodejs_sitearch}/sqlite3


%changelog
* Thu Mar 21 2013 Tom Hughes <tom@compton.nu> - 2.1.7-1
- Update to 2.1.7 upstream release
- Switch to running tests using mocha
- Filter out provide for Node.js native extension
- Enable tests

* Wed Mar 13 2013 Tom Hughes <tom@compton.nu> - 2.1.5-4
- Restrict supported architectures using ExclusiveArch
- Rebuild against node 0.10

* Mon Mar  4 2013 Tom Hughes <tom@compton.nu> - 2.1.5-3
- Fix gcc 4.8 compilation issues

* Sat Mar  2 2013 Tom Hughes <tom@compton.nu> - 2.1.5-2
- Fix permissions on node_sqite3.node
- Improve description

* Sun Feb 10 2013 Tom Hughes <tom@compton.nu> - 2.1.5-1
- Initial build of 2.1.5
